import { statisticsFetch } from '../../api/fetch';
import { formatTime } from '../../utils/util';

// miniprogram/pages/home/home.js
Component({
  pageLifetimes: {
    show() {
      !this.data.fetched && this.fetchRechargeData();
      if (typeof this.getTabBar === 'function' && this.getTabBar()) {
        this.getTabBar().setData({
          selected: 0,
        });
      }
    },
  },
  /**
   * 页面的初始数据
   */
  data: {
    timeType: 0,
    fetched: false,
    rechargeData: {
      title: '充值总额',
      numberType: 'price',
      count: 0,
    },
    rechargeCount: {
      title: '充值总笔数',
      numberType: '',
      count: 0,
    },
    onlineRechargeData: {
      title: '线上充值',
      numberType: '1',
      count: 0,
      price: 0,
    },
    offlineRechargeData: {
      title: '线下充值',
      numberType: '1',
      count: 0,
      price: 0,
    },
    comsumerData: {
      title: '消费总额',
      numberType: 'price',
      count: 0,
    },
    comsumerCount: {
      title: '消费总笔数',
      numberType: '',
      count: 0,
    },
    refundData: {
      title: '退款总额',
      numberType: 'price',
      count: 0,
    },
    refundCount: {
      title: '退款总笔数',
      numberType: '',
      count: 0,
    },
    testData: {
      title: '充值总额',
      numberType: 'price',
      count: 0,
    },
    testData2: {
      title: '线上充值',
      numberType: '1',
      count: 0,
      price: 0,
    },
  },
  methods: {
    changeTimeType(e) {
      const { timetype } = e.currentTarget.dataset;
      if (timetype === this.data.timeType) return;
      this.setData({
        timeType: timetype,
      });
      this.fetchRechargeData(timetype);
      return false;
    },
    fetchRechargeData(timeType?: number) {
      if (!timeType) timeType = this.data.timeType;
      const today = formatTime(new Date());
      let date = today.split(' ')[0];
      let entity = {};
      if (timeType === 0) {
        entity.date = date;
      } else if (timeType === 1) {
        entity.month = date.slice(0, 7);
      } else if (timeType === 2) {
        entity.year = date.slice(0, 4);
      }
      wx.showLoading({ title: '' });
      statisticsFetch({
        url: '/dcxy/reportInfo/queryRechargeOrderListV2',
        method: 'POST',
        data: entity,
      })
        .then(res => {
          wx.hideLoading();
          const data = res.rechargeOrderCountVo;
          if (data) {
            const {
              rechargeMen,
              rechargeMoney,
              refundCount,
              refundMoney,
              offlineRechargeMen,
              offlineRechargeMoney,
              onlineRechargeMen,
              onlineRechargeMoney,
            } = data;
            this.setData({
              'rechargeData.count': rechargeMoney,
              'rechargeCount.count': rechargeMen,
              'refundData.count': refundMoney,
              'refundCount.count': refundCount,
              'onlineRechargeData.price': onlineRechargeMoney,
              'onlineRechargeData.count': onlineRechargeMen,
              'offlineRechargeData.price': offlineRechargeMoney,
              'offlineRechargeData.count': offlineRechargeMen,
            });
          }
        })
        .catch((err: wx.GeneralCallbackResult) => {
          wx.hideLoading();
          wx.showToast({
            title: err.errMsg,
          });
          console.log(err);
        });
    },
  },
});
