//index.js
import { systemFetch } from '../../api/fetch';
import md5 from 'blueimp-md5';
//获取应用实例
import { IMyApp } from '../../app';
const app = getApp<IMyApp>();

Page({
  data: {
    account: '',
    pwd: '',
    showPassword: false,
  },
  togglePassword() {
    this.setData!({
      showPassword: !this.data.showPassword,
    });
  },
  validateLoginData() {
    const { account, pwd } = this.data;
    if (!account) {
      wx.showToast({
        title: '请输入账户',
      });
      return;
    }
    if (!pwd) {
      wx.showToast({
        title: '请输入密码',
      });
      return;
    }
    return true;
  },
  loginHandle() {
    if (this.validateLoginData()) {
      const { account, pwd } = this.data;
      console.log(account, pwd);
      systemFetch({
        url: '/login/verifyCode',
      })
        .then((res: wx.RequestSuccessCallbackResult) => {
          console.log(res);
          return {
            code: res.data.verifyCode,
            cookie: res.header['Set-Cookie'],
          };
        })
        .then(({ code, cookie }: { code: string; cookie: string }) =>
          systemFetch({
            url: '/login',
            method: 'POST',
            header: {
              cookie: cookie,
            },
            data: {
              account,
              pwd: md5(pwd),
              varifyCode: code,
            },
          }),
        )
        .then(res => {
          console.log(res);
        })
        .catch(err => {
          console.log(err);
        });
    }
    // fetch()
    // wx.redirectTo({
    //   url: '/pages/home/home'
    // })
  },
  nameInputHandle(e) {
    const value = e.detail.value;
    this.updateInputValue('account', value);
  },
  passwardInoutHandle(e) {
    const value = e.detail.value;
    this.updateInputValue('pwd', value);
  },
  updateInputValue(key: string, value: string) {
    this.setData!({
      [key]: value,
    });
  },
  onLoad() {},
});
